searchNodes=[{"doc":"","ref":"Exemvi.CRC.html","title":"Exemvi.CRC","type":"module"},{"doc":"","ref":"Exemvi.CRC.html#checksum_hex/1","title":"Exemvi.CRC.checksum_hex/1","type":"function"},{"doc":"","ref":"Exemvi.Error.html","title":"Exemvi.Error","type":"module"},{"doc":"","ref":"Exemvi.Error.html#invalid_object_id/0","title":"Exemvi.Error.invalid_object_id/0","type":"function"},{"doc":"","ref":"Exemvi.Error.html#invalid_object_value/1","title":"Exemvi.Error.invalid_object_value/1","type":"function"},{"doc":"","ref":"Exemvi.Error.html#invalid_qr/0","title":"Exemvi.Error.invalid_qr/0","type":"function"},{"doc":"","ref":"Exemvi.Error.html#invalid_value_length/0","title":"Exemvi.Error.invalid_value_length/0","type":"function"},{"doc":"","ref":"Exemvi.Error.html#missing_object_id/1","title":"Exemvi.Error.missing_object_id/1","type":"function"},{"doc":"","ref":"Exemvi.Error.html#orphaned_object/1","title":"Exemvi.Error.orphaned_object/1","type":"function"},{"doc":"Core functions for Merchant-Presented Mode QR Code","ref":"Exemvi.QR.MP.html","title":"Exemvi.QR.MP","type":"module"},{"doc":"Parse QR Code into data objectsReturns either:{:ok, objects} where objects is a list of Exemvi.MP.Object structs{:error, reasons} where reasons is a list of error reasons as atoms","ref":"Exemvi.QR.MP.html#parse_to_objects/1","title":"Exemvi.QR.MP.parse_to_objects/1","type":"function"},{"doc":"Validate data objectsReturns either:{:ok, objects} where objects is the objects originally supplied to the function{:error, reasons} where reasons is a list of validation error reasons as atoms","ref":"Exemvi.QR.MP.html#validate_objects/1","title":"Exemvi.QR.MP.validate_objects/1","type":"function"},{"doc":"Validate whole QR CodeReturns either:{:ok, qr_code} where qr_code is the QR Code orginally supplied to the function{:error, reasons} where reasons is a list of validation error reasons as atoms","ref":"Exemvi.QR.MP.html#validate_qr/1","title":"Exemvi.QR.MP.validate_qr/1","type":"function"},{"doc":"Merchant-Presented Mode data objectProperties::id is a string of data object ID:value is a string of data object value. The value is nil if the data object is a template:objects is a list of data objects in the template. The value is nil if the data object is not a template","ref":"Exemvi.QR.MP.Object.html","title":"Exemvi.QR.MP.Object","type":"module"},{"doc":"","ref":"Exemvi.QR.MP.Object.html#id_atoms/1","title":"Exemvi.QR.MP.Object.id_atoms/1","type":"function"},{"doc":"","ref":"Exemvi.QR.MP.Object.html#id_raw/2","title":"Exemvi.QR.MP.Object.id_raw/2","type":"function"},{"doc":"","ref":"Exemvi.QR.MP.Object.html#specs/1","title":"Exemvi.QR.MP.Object.specs/1","type":"function"},{"doc":"ExemviExemvi is a library to work with EMV QR Code Specification for Payment Systems.Exemvi only supports validating and parsing Merchant-Presented Mode (MPM) QR Code. Support for generating MPM QR Code is planned for future versions.At this moment, support for Consumer-Presented Mode (CPM) is not planned.The specifications of EMV QR Code can be found at https://www.emvco.com/emv-technologies/qrcodes/InstallationAdd exemvi to your list of dependencies in mix.exs:def deps do [ {:exemvi, &quot;~&gt; 0.1.0&quot;} ] endBasic UsageValidating the whole QR Code:qr_code = &quot;qr_code_string&quot; result = Exemvi.QR.MP.validate_qr(qr_code)The result is either:{:ok, qr_code} where qr_code is the QR Code orginally supplied to the function{:error, reasons} where reasons is a list of validation error reasons as atomsParsing QR Code into data objects:qr_code = &quot;qr_code_string&quot; result = Exemvi.QR.MP.parse_to_objects(qr_code)The result is either:{:ok, objects} where objects is a list of Exemvi.MP.Object structs{:error, reasons} where reasons is a list of parsing error reasons as atomsValidating parsed data objects:objects = [%Exemvi.QR.MP.Object{id: &quot;00&quot;, value: &quot;01&quot;}, ...] result = Exemvi.QR.MP.validate_objects(qr_code)The result is either:{:ok, objects} where objects is the objects originally supplied to the function{:error, reasons} where reasons is a list of validation error reasons as atomsAll three functions above can be piped:result = qr_code |&gt; Exemvi.QR.MP.validate_qr() |&gt; Exemvi.QR.MP.parse_to_objects() |&gt; Exemvi.QR.MP.validate_objects()All possible error reason atoms in this library are in Exemvi.Error module.ExampleLet's try parsing the official sample.official_sample = &quot;00020101021229300012D156000000000510A93FO3230Q31280012D15600000001030812345678520441115802CN5914BEST TRANSPORT6007BEIJING64200002ZH0104最佳运输0202北京540523.7253031565502016233030412340603***0708A60086670902ME91320016A0112233449988770708123456786304A13A&quot; {:ok, objects} &lt;- Exemvi.QR.MP.parse_to_objects(official_sample)The resulting objects looks like below:[ %Exemvi.QR.MP.Object{id: &quot;00&quot;, objects: nil, value: &quot;01&quot;}, %Exemvi.QR.MP.Object{id: &quot;01&quot;, objects: nil, value: &quot;12&quot;}, %Exemvi.QR.MP.Object{ id: &quot;29&quot;, objects: [ %Exemvi.QR.MP.Object{id: &quot;00&quot;, objects: nil, value: &quot;D15600000000&quot;}, %Exemvi.QR.MP.Object{id: &quot;05&quot;, objects: nil, value: &quot;A93FO3230Q&quot;} ], value: nil }, %Exemvi.QR.MP.Object{ id: &quot;31&quot;, objects: [ %Exemvi.QR.MP.Object{id: &quot;00&quot;, objects: nil, value: &quot;D15600000001&quot;}, %Exemvi.QR.MP.Object{id: &quot;03&quot;, objects: nil, value: &quot;12345678&quot;} ], value: nil }, #... Other objects are removed for brevity ]Let's try validating an obviously invalid QR Code.wrong_qr_code = &quot;0002XX&quot; {:error, reasons} = Exemvi.QR.MP.validate_qr(wrong_qr_code)The resulting error reason is [:invalid_qr]","ref":"readme.html","title":"Exemvi","type":"extras"}]